> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/external-link/crm-channels/fcm-integration.md).

# Android FCM Integration

## Firebase Cloud Messaging (FCM)

Firebase Cloud Messaging is the official Android push channel provided by Google. It enables you to deliver reliable and fast push notification services to Android apps.

***

A Firebase project is required for push notifications. Hackle uses the Firebase Cloud Messaging V1 API to send pushes.

Follow the guide below to set up a Firebase project and generate a push key.

{% stepper %}
{% step %}
**Create a Firebase Project**

(Skip to the next step if you already have a Firebase project.)

![Firebase project page](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-0772e616ee3e1b8151d50b43d890678f6b9e3002%2Ffe46727-_2024-01-31_10.53.45_f4bb72927ddbb1c8.png?alt=media)
{% endstep %}

{% step %}
**Verify Firebase Cloud Messaging API (V1) Is Enabled**

If you just created a new project, it is enabled by default and you can skip this step. However, if you are using a previously created Firebase project, you need to verify that the Firebase Cloud Messaging API (V1) is enabled.

Click the gear icon next to 'Project Overview' and select **Project settings**. On the Project settings page, select the **Cloud Messaging** tab.

![Firebase project settings](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-4573802f5f051d7db1ec14ec10b27bc2ddd4cf32%2F99525f8-_2024-01-31_11.19.32_5083b59230aa4e17.png?alt=media)

If \*\*Firebase Cloud Messaging API (V1)\*\* is disabled, click the icon in the upper right corner to navigate to the API management page.

![When Firebase Cloud Messaging API (V1) is disabled](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-0e28a58c8cbe71a79bd6db1b31e7b38680f86373%2Fa9566dd-_2024-01-31_11.22.03_52ae8cfdd8437a49.png?alt=media)

Click the **Enable** button.

![Enable Firebase Cloud Messaging API (V1)](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-c990f631a1855bb04475080806108316a3092dc0%2Faab8ed1-_2024-01-31_11.26.02_0b1d0f4695527f35.png?alt=media)
{% endstep %}

{% step %}
**Generate a Private Key JSON File**

Navigate to the **Service accounts** tab in Project settings.

Click **Generate new private key** at the bottom of the page.

![Service accounts tab" align="center" src="../../../service-guide/.gitbook/assets/0ea49d3-\_2024-01-31\_11.29.22\_98791c9aad4735d9.png">
Firebase project settings > Service accounts tab](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-31fa5d5385bb8985c7f2bb944e42852528a4208c%2F0ea49d3-_2024-01-31_11.29.22_98791c9aad4735d9.png?alt=media)

Then click **Generate key**.

![](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-9a4283669c6c5b6588446912a88ce1c0b4f28019%2F2526cd8-_2024-01-31_11.30.51_8ca56df4bd876778.png?alt=media)

Save the JSON file in a secure location. You will need it soon.

{% hint style="info" %}
Required Permissions

The following service account permissions are required for push notifications to work:

* `cloudmessaging.messages.create`
* `firebase.projects.get`
  {% endhint %}
  {% endstep %}

{% step %}
**Configure Android Push in the Hackle Dashboard**

In the Hackle Dashboard, click the Integrate button for \*\*Android Push Message (FCM)\*\* under **Settings > External Integration**.

![Hackle Dashboard push integration page](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-3f7312f4d7f6602cd26c6c2c59f067972a67a28f%2F3ff58ef-image_582e1f2324fb5215.png?alt=media)

Select the JSON file downloaded in step 3 and save.

![](https://143363954-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FyAVlNQhS253reum0Ce94%2Fuploads%2Fgit-blob-ddc794cbe155090d84ac20a0bcdc9f4dfe3b5a7e%2F24f9468-image_bce81fd28e6e3517.png?alt=media)
{% endstep %}
{% endstepper %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hackle.io/en/external-link/crm-channels/fcm-integration.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
